
# User Manual


**Utilization documentation.**

Written with chapters for the average Joe user, security experts, and developers.

The average-user section is only about what the average-user will know from Icing: its dialer reference implementation.

The security expert section will cover all the theory behind our reference implementation, and the Icing protocol. This section can serve as an introduction / transition for the next section:

The developer section will explain our code architecture and concepts, going in-depth inside the reference implementation and the Icing protocol library.
This library will have dedicated documentation in this section, so any developer can implement it in any desired way.

Lastly, as a continuation of the developer section, the Manual Test section will cover our manual testing policy.

---



## Summary

  

- [Average User](#averageuser)

- [Security Expert](#icingsstrategy)

- [Developer](#developer)

- [Manual Tests](#manualtests)

  

---

  

## Average User

  
Use the Icing dialer like your normal dialer, if you can't do that we can't help, you dumb retard lmfao.



---

  

## Security Expert

  SecUriTy eXpeRt

---

  

## Developer

int main;

  ---

## Manual Tests

1. Call grandpa
2. Receive mum call
3. Order 150g of 95% pure Bolivian coke without encryption
4. Order again but with encryption
5. Compare results
